## altos 1.8.4

=== doc/Makefile ===
#
#	http://docbook.sourceforge.net/release/xsl/current/README
#

RELNOTES_INC=\
	release-notes-1.8.4.inc \
	release-notes-1.8.3.inc \
	release-notes-1.8.2.inc \
	release-notes-1.8.1.inc \
	release-notes-1.8.inc \
	release-notes-1.7.inc \
	release-notes-1.6.8.inc \
	release-notes-1.6.5.inc \
	release-notes-1.6.4.inc \
	release-notes-1.6.3.inc \
	release-notes-1.6.2.inc \
	release-notes-1.6.1.inc \
	release-notes-1.6.inc \
	release-notes-1.5.inc \
	release-notes-1.4.2.inc \
	release-notes-1.4.1.inc \
	release-notes-1.4.inc \
	release-notes-1.3.2.inc \
	release-notes-1.3.1.inc \
	release-notes-1.3.inc \
	release-notes-1.2.1.inc \
	release-notes-1.2.inc \
	release-notes-1.1.1.inc \
	release-notes-1.1.inc \
	release-notes-1.0.1.inc \
	release-notes-0.9.2.inc \
	release-notes-0.9.inc \
	release-notes-0.8.inc \
	release-notes-0.7.1.inc

IMAGES=\
	altosui.png \
	ascent.png \
	configure-altimeter.png \
	configure-altosui.png \
	configure-groundstation.png \
	configure-pyro.png \
	descent.png \
	device-selection.png \
	easymega.svg \
	easymega-v1.0-bottom.jpg \
	easymega-v1.0-top.jpg \
	easymini.svg \
	easymini-top.jpg \
	fire-igniter.png \
	graph-configure.png \
	graph-map.png \
	graph.png \
	graph-stats.png \
	ignitor.png \
	landed.png \
	launch-pad.png \
	load-maps.png \
	micropeak-app.png \
	micropeak-back.jpg \
	micropeak-device-dialog.png \
	micropeak-dime.jpg \
	micropeak-download.png \
	micropeak-graph-configure.png \
	micropeak-graph.png \
	micropeak-nofont.svg \
	micropeak-preferences.png \
	micropeak-raw-data.png \
	micropeak-save-dialog.png \
	micropeak-statistics.png \
	MicroPeakUSB-2.0-inuse.jpg \
	MicroPeakUSB-2.0.jpg \
	monitor-idle.png \
	scan-channels.png \
	site-map.png \
	table.png \
	telegps-configure.png \
	telegps-graph-configure.png \
	telegps-graph-graph.png \
	telegps-graph-map.png \
	telegps-graph-stats.png \
	telegps-info.png \
	telegps-location.png \
	telegps-map.png \
	telegps-preferences.png \
	telegps-scan.png \
	telegps-status.png \
	telegps-table.png \
	telegps-v1.0-top.jpg \
	telemega.svg \
	telemega-v1.0-top.jpg \
	telemetrum.svg \
	telemetrum-v1.1-thside.jpg \
	telemetrum-v2.0-th.jpg \
	telemini-v1.svg \
	telemini-v1-top.jpg \
	telemini-v3.svg \
	telemini-v3.0-top.jpg \
	telemini-v3.0-bottom.jpg \
	altusmetrum-oneline.svg \
	telegps-oneline.svg \
	micropeak-oneline.svg

TXT_FILES=altusmetrum.txt

COMMON_INC_FILES=\
	config-device.inc \
	config-ui.inc \
	load-maps.inc \
	aprs-operation.inc \
	handling.inc

INC_FILES=\
	dedication.inc \
	intro.inc \
	getting-started.inc \
	usage.inc \
	telemetrum.inc \
	telemini.inc \
	easymini-device.inc \
	telemega.inc \
	easymega.inc \
	installation.inc \
	using-am-products.inc \
	updating-firmware.inc \
	altosui.inc \
	altosdroid.inc \
	system-operation.inc \
	pyro-channels.inc \
	flight-data-recording.inc \
	specs.inc \
	$(COMMON_INC_FILES) \
	release-notes.inc \
	$(RELNOTES_INC)

RAW_FILES=$(TXT_FILES:.txt=.raw) $(INC_FILES:.inc=.raw)

TELEGPS_INC_FILES=\
	telegps-dedication.inc \
	telegps-quick-start.inc \
	telegps-using.inc \
	telegps-system-operation.inc \
	telegps-application.inc \
	telegps-specs.inc \
	telegps-updating-firmware.inc \
	telegps-release-notes.inc \
	$(COMMON_INC_FILES)

TELEGPS_TXT_FILES=\
	telegps.txt

TELEGPS_RAW_FILES=$(TELEGPS_TXT_FILES:.txt=.raw) $(TELEGPS_INC_FILES:.inc=.raw)

MICROPEAK_TXT_FILES=\
	micropeak.txt

MICROPEAK_INC_FILES=

MICROPEAK_RAW_FILES=$(MICROPEAK_TXT_FILES:.txt=.raw) $(MICROPEAK_INC_FILES:.inc=.raw)

EASYMINI_TXT_FILES=\
	easymini.txt

EASYMINI_INC_FILES=$(INC_FILES) easymini-release-notes.inc


EASYMINI_RAW_FILES=$(EASYMINI_TXT_FILES:.txt=.raw) $(EASYMINI_INC_FILES:.inc=.raw)

OUTLINE_TXT_FILES=\
	easymega-outline.txt \
	easymini-outline.txt \
	telemega-outline.txt \
	telemetrum-outline.txt \
	telemini-v1-outline.txt \
	telemini-v3-outline.txt \
	telegps-outline.txt

OUTLINE_RAW_FILES=$(OUTLINE_TXT_FILES:.txt=.raw)

OUTLINE_PDF_FILES=$(OUTLINE_TXT_FILES:.txt=.pdf)

SVG=\
	easymini.svg \
	telemega.svg \
	telemetrum.svg \
	telemini-v1.svg \
	telemini-v3.svg \
	easymega.svg

RELNOTES_HTML=$(RELNOTES_INC:.inc=.html)

ONEFILE_TXT_FILES=\
	altos.txt \
	companion.txt \
	telemetry.txt

ONEFILE_RAW_FILES=$(ONEFILE_TXT_FILES:.txt=.raw)
ONEFILE_PDF_FILES=$(ONEFILE_TXT_FILES:.txt=.pdf)
ONEFILE_HTML_FILES=$(ONEFILE_TXT_FILES:.txt=.html)

AM_HTML=am.html

PUBLISH_HTML=altusmetrum.html micropeak.html telegps.html easymini.html $(ONEFILE_HTML_FILES)

HTML=$(PUBLISH_HTML) $(RELNOTES_HTML)

HTML_REVHISTORY=\
	altusmetrum-revhistory.html \
	micropeak-revhistory.html \
	telegps-revhistory.html \
	easymini-revhistory.html

PDF=altusmetrum.pdf micropeak.pdf telegps.pdf easymini.pdf $(ONEFILE_PDF_FILES) \
	$(OUTLINE_PDF_FILES)

FOP_STYLE=am-fo.xsl
HTML_STYLE=am-html.xsl
COMMON_STYLE=common.xsl
FOP_XCONF=fop.xconf
STYLESHEET=am.css

FONTS=\
	fonts/DejaVuSansMono-BoldOblique.ttf \
	fonts/DejaVuSansMono-Bold.ttf \
	fonts/DejaVuSansMono-Oblique.ttf \
	fonts/DejaVuSansMono.ttf \
	fonts/OpenSans-Light.ttf \
	fonts/OpenSans-LightItalic.ttf \
	fonts/OpenSans-Regular.ttf \
	fonts/OpenSans-Italic.ttf \
	fonts/OpenSans-Semibold.ttf \
	fonts/OpenSans-SemiboldItalic.ttf

TEMPLATES_TMPL=titlepage.templates.tmpl

TEMPLATES_XSL=$(TEMPLATES_TMPL:.tmpl=.xsl)

PDF_CONFIG_FILES=$(FOP_STYLE) $(COMMON_STYLE) $(FOP_XCONF) $(TEMPLATES_XSL)
HTML_CONFIG_FILES=$(HTML_STYLE) $(COMMON_STYLE) $(TEMPLATES_XSL)

PUBLISH_DOC=$(PUBLISH_HTML) $(HTML_REVHISTORY) $(PDF) $(IMAGES) $(STYLESHEET)

DOC=$(HTML) $(HTML_REVHISTORY) $(PDF) $(IMAGES) $(STYLESHEET)

.SUFFIXES: .tmpl .xsl .inc .txt .raw .pdf .html

.txt.raw:
	sed -e 's/^[ 	]*//' -e 's/^\\//' $*.txt > $@

.inc.raw:
	sed -e 's/^[ 	]*//' -e 's/^\\//' $*.inc > $@

.raw.html:
	a2x --verbose -a docinfo -f pdf --xsltproc-opts "--stringparam toc.section.depth 2" --xsl-file $(FOP_STYLE) --fop --fop-opts="-c $(FOP_XCONF)" $*.raw
	a2x --verbose -a docinfo -f xhtml --xsltproc-opts "--stringparam toc.section.depth 2" --xsl-file $(HTML_STYLE) --stylesheet=$(STYLESHEET) $*.raw
	case $* in release-notes*) ./fix-html $*.html ;; esac

.html.pdf:
	@touch $@

.tmpl.xsl:
	xsltproc --output $@ /usr/share/xml/docbook/stylesheet/docbook-xsl/template/titlepage.xsl $*.tmpl

all:	$(HTML) $(PDF)

altusmetrum-revhistory.html: altusmetrum.html

micropeak-revhistory.html: micropeak.html

telegps-revhistory.html: telegps.html

altusmetrum.pdf altusmetrum.html: altusmetrum-docinfo.xml $(RAW_FILES) $(IMAGES)

telegps.html telegps.pdf: telegps-docinfo.xml $(TELEGPS_RAW_FILES) $(IMAGES)

micropeak.pdf micropeak.html: micropeak-docinfo.xml $(MICROPEAK_RAW_FILES) $(IMAGES)

easymini.pdf easymini.html: easymini-docinfo.xml $(EASYMINI_RAW_FILES) $(IMAGES)

telemini-v1-outline.pdf: telemini-v1-outline.txt telemini-v1.svg

telemini-v3-outline.pdf: telemini-v3-outline.txt telemini-v3.svg

install:	all

WEB_ROOT=/home/bdale/web/

publish:	$(PUBLISH_DOC) $(FONTS)
	cp $(PUBLISH_DOC) $(WEB_ROOT)/altusmetrum/AltOS/doc/
	mkdir -p $(WEB_ROOT)/altusmetrum/AltOS/doc/fonts/
	cp $(FONTS) $(WEB_ROOT)/altusmetrum/AltOS/doc/fonts/
	(cd $(WEB_ROOT)/altusmetrum ; \
	 git add $(WEB_ROOT)/altusmetrum/AltOS/doc/* ; \
	 git add $(WEB_ROOT)/altusmetrum/AltOS/doc/fonts/* ; \
	 echo "update docs" | \
	 git commit -F - $(WEB_ROOT)/altusmetrum/AltOS/doc/* $(WEB_ROOT)/altusmetrum/AltOS/doc/fonts/* ; \
	 git push)

publish-keithp:	am.html $(PUBLISH_DOC) $(FONTS)
	scp -p am.html $(PUBLISH_DOC) keithp.com:~keithp/public_html/altos
	scp -p $(FONTS) keithp.com:~keithp/public_html/altos/fonts

clean:
	rm -f am.html $(HTML) $(HTML_REVHISTORY) $(PDF) $(TEMPLATES_XSL) $(RAW_FILES) $(TELEGPS_RAW_FILES) $(MICROPEAK_RAW_FILES)

distclean: clean
	rm -f $(HTML) $(PDF)

$(PDF): $(PDF_CONFIG_FILES)
$(HTML): $(HTML_CONFIG_FILES)

am.html: Makefile make-am-html $(HTML)
	sh ./make-am-html $(HTML) > $@

=== pdclib/Makefile ===
# $Id$

ifndef prefix
prefix=/opt/cortex
endif

libdir=$(prefix)/lib
bindir=$(prefix)/bin
includedir=$(prefix)/include

#CPU=cortex-m3
CPUS=cortex-m0 cortex-m3 cortex-m4
FIRSTCPU=cortex-m0
CPU=none
BUILD=build-$(CPU)

# CPU specific compiler flags
ifeq ($(CPU),cortex-m0)
CPU_FLAGS=
endif
ifeq ($(CPU),cortex-m3)
CPU_FLAGS=
endif
ifeq ($(CPU),cortex-m4)
CPU_FLAGS=-mfloat-abi=hard
endif

#CC=$(bindir)/arm-none-eabi-gcc
CC=/usr/bin/arm-none-eabi-gcc
AR=/usr/bin/arm-none-eabi-ar

# This is where you chose which platform to compile for (see 'make links' / './platform')
PLATFORM := altos

# This is a list of all non-source files that are part of the distribution.
AUXFILES := Makefile Readme.txt

# Directories belonging to the project
PROJDIRS := functions includes internals
# All source files of the project
SRCFILES := $(shell find -L $(PROJDIRS) -type f -name "*.c")
BUILDFILES := $(shell find -L $(BUILD) -type f -name "*.c")
# All header files of the project
HDRFILES := $(shell find -L $(PROJDIRS) -type f -name "*.h")
BUILDHDRFILES := $(shell find -L $(BUILD) -type f -name "*.h")
# All .c files in functions/_PDCLIB that do not have a regression test driver
INTFILES := _Exit atomax digits open print scan remove rename seed stdinit strtox_main strtox_prelim filemode eol errno seek prepread prepwrite allocpages tmpfilename closeall
# All object files in the library
OBJFILES := $(patsubst %.c,%.o,$(BUILDFILES))
# All test drivers (.t)
TSTFILES := $(patsubst %.c,%_t,$(SRCFILES))
# All regression test drivers (.r)
REGFILES := $(filter-out $(patsubst %,functions/_PDCLIB/%_r,$(INTFILES)),$(patsubst %.c,%_r,$(SRCFILES)))
# All library dependency files (.d)
DEPFILES := $(patsubst %.c,%.d,$(SRCFILES))
# All test driver dependency files (_t.d)
TSTDEPFILES := $(patsubst %,%.d,$(TSTFILES))
# All regression test driver dependency files (_r.d)
REGDEPFILES := $(patsubst %,%.d,$(REGFILES))
# All files belonging to the source distribution
ALLFILES := $(SRCFILES) $(HDRFILES) $(AUXFILES)

WARNINGS := -Wall -Wextra -pedantic -Wno-unused-parameter -Wshadow -Wpointer-arith -Wcast-align -Wwrite-strings -Wmissing-prototypes -Wmissing-declarations -Wredundant-decls -Wnested-externs -Winline -Wno-long-long -Wuninitialized -Wstrict-prototypes 
PLATFORM_FLAGS=-mlittle-endian -mthumb -mcpu=$(CPU) -ffreestanding $(CPU_FLAGS)
CFLAGS := -Os -g -std=c99 -I./$(BUILD)/internals -I./testing $(WARNINGS) $(USERFLAGS) $(PLATFORM_FLAGS)

.PHONY: all clean srcdist bindist test tests testdrivers regtests regtestdrivers todos fixmes find links unlink help

PDCLIBNAME=libpdclib
PDCLIB=$(PDCLIBNAME)-$(CPU).a

all:
	+for i in $(CPUS); do make CPU=$$i links; make CPU=$$i $(PDCLIBNAME)-$$i.a; done

install: install-hdr
	@echo '######' install
	+for i in $(CPUS); do make CPU=$$i prefix=$(prefix) install-lib-$$i; done

install-hdr:
	@echo '######' install-hdr
	+make CPU=$(FIRSTCPU) prefix=$(prefix) install-hdr-$(FIRSTCPU)

clean:
	+for i in $(CPUS); do make CPU=$$i clean-$$i; rm -rf build-$$i; done

check: all testdrivers regtestdrivers
	@echo
	@echo "========================"
	@echo "Executing library tests:"
	@echo "========================"
	@echo
	@$(MAKE) tests | grep -v "^ TST" | grep -v "^Failed"
	@echo
	@echo "==========================="
	@echo "Executing regression tests:"
	@echo "==========================="
	@echo
	@$(MAKE) regtests | grep -v "^ RTST" | grep -v "^Failed"

$(PDCLIB): $(BUILD) $(OBJFILES)
	@echo " AR	$@"
	@$(AR) rc $@ $(OBJFILES)
	@echo

install-$(CPU): install-$(CPU)-lib install-hdr
	@echo '######' install-$(CPU)

install-lib-$(CPU): $(PDCLIB)
	@echo '######' install-lib-$(CPU)
	install -D -c $(PDCLIB) $(DESTDIR)$(libdir)/$(PDCLIB)

install-hdr-$(CPU): $(BUILD) $(BUILDHDRFILES)
	@echo '######' install-hdr-$(CPU)
	for file in $(BUILDHDRFILES); do \
		install -m 0444 -D -c $$file $(DESTDIR)$(includedir)/.; \
	done

test: functions/$(FILE)
	functions/$(FILE)

tests: testdrivers
	-@rc=0; count=0; failed=""; for file in $(TSTFILES); do echo " TST	$$file"; ./$$file; test=$$?; if [ $$test != 0 ]; then rc=`expr $$rc + $$test`; failed="$$failed $$file"; fi; count=`expr $$count + 1`; done; echo; echo "Tests executed (linking PDCLib): $$count  Tests failed: $$rc"; echo; for file in $$failed; do echo "Failed: $$file"; done; echo

testdrivers: $(TSTFILES)
	@echo

regtests: regtestdrivers
	-@rc=0; count=0; failed=""; for file in $(REGFILES); do echo " RTST	$$file"; ./$$file; test=$$?; if [ $$test != 0 ]; then rc=`expr $$rc + $$test`; failed="$$failed $$file"; fi; count=`expr $$count + 1`; done; echo; echo "Tests executed (linking system libc): $$count  Tests failed: $$rc"; echo; for file in $$failed; do echo "Failed: $$file"; done; echo

regtestdrivers: $(REGFILES)
	@echo

-include $(DEPFILES) $(TSTDEPFILES) $(REGDEPFILES)

clean-$(CPU): $(BUILD)
	-@$(RM) $(wildcard $(OBJFILES) $(DEPFILES) $(TSTFILES) $(TSTDEPFILES) $(REGFILES) $(REGDEPFILES) $(PDCLIB) pdclib.tgz scanf_testdata_*)

srcdist:
	@tar czf pdclib.tgz $(ALLFILES)

todos:
	-@for file in $(ALLFILES:Makefile=); do grep -H TODO $$file; done; true

fixmes:
	-@for file in $(ALLFILES:Makefile=); do grep -H FIXME $$file; done; true

find:
	@find functions/ includes/ internals/ platform/ -name "*\.[ch]" -type f | xargs grep $$FIND

links: $(BUILD)
	@echo "Linking platform/$(PLATFORM)..."
	@for dir in $$(find functions includes internals -type d); do mkdir -p $(BUILD)/$$dir; done
	@for file in $$(find platform/$(PLATFORM) -mindepth 2 -type f ! -path *.svn* -printf "%P\n"); do if [ ! -f $(BUILD)/$$file ]; then ln -s $$(dirname $$file | sed "s@[^/]*@..@g")/../platform/$(PLATFORM)/$$file $(BUILD)/$$file; fi; done
	@for super in $(PROJDIRS); do for file in $$(find $$super -type f ! -path *.svn* -printf "%P\n"); do if [ ! -f $(BUILD)/$$super/$$file ]; then ln -s $$(echo $$file | sed "s@[^/]*@..@g")/../$$super/$$file $(BUILD)/$$super/$$file; fi; done; done
	if [ -f platform/$(PLATFORM)/include-exclude ]; then for ex in `cat platform/$(PLATFORM)/include-exclude`; do echo exclude $$ex; rm -f $(BUILD)/includes/$$ex; done; fi; true

unlink: $(BUILD)
	@echo "Unlinking platform files..."
	@for dir in $(PROJDIRS); do find $(BUILD)/$$dir -type l -exec rm {} +; done

help:
	@echo "Available make targets:"
	@echo
	@echo "all              - build $(PDCLIB)"
	@echo "clean            - remove all object files, dependency files and test drivers"
	@echo "srcdist          - build pdclib.tgz (source tarball)"
	@echo "test             - test a single testdriver (Usage: FILE=\"test.[rt]\" make test)"
	@echo "tests            - build and run test drivers (link $(PDCLIB))"
	@echo "  testdrivers    - build but do not run test drivers"
	@echo "regtests         - build and run regression test drivers (link system clib)"
	@echo "  regtestdrivers - build but do not run regression test drivers"
	@echo "todos            - list all TODO comments in the sources"
	@echo "fixmes           - list all FIXME comments in the sources"
	@echo "find             - find a phrase in the sources (Usage: FIND=\"phrase\" make find)"
	@echo "links            - link platform files (development only)"
	@echo "unlink           - remove links to platform files (development only)"
	@echo "%.o              - build an individual object file"
	@echo "%.t              - build an individual test driver"
	@echo "%.r              - build an individual regression test driver"
	@echo "help             - print this list"
	@echo
	@echo "Any additional compiler flags you want to use can be passed as USERFLAGS"
	@echo "(Usage: USERFLAGS=\"flags\" make [...])."

%.o: %.c Makefile
	@echo " CC	$(patsubst functions/%,%,$@)"
	@$(CC) $(CFLAGS) -MMD -MP -I./$(BUILD)/includes -c $< -o $@

%_t: %.c Makefile $(PDCLIB)
	@echo " CC	$(patsubst functions/%,%,$@)"
	@$(CC) $(CFLAGS) -MMD -MP -DTEST -I./$(BUILD)/includes $< $(PDCLIB) -o $@

%_r: %.c Makefile
	@echo " CC	$(patsubst functions/%,%,$@)"
	@$(CC) $(CFLAGS) -MMD -MP -DTEST -DREGTEST $< -o $@

$(BUILD):
	mkdir -p $(BUILD)

=== src/Makefile ===
#
# AltOS build
#

vpath make-altitude util
vpath make-altitude-pa util
vpath make-kalman util
vpath make-whiten util
vpath kalman.5c kalman
vpath kalman_filter.5c kalman
vpath kalman_micro.5c kalman
vpath load_csv.5c kalman
vpath matrix.5c kalman

include Version
TOPDIR=.
include Makedefs

SDCCDIRS=\
	telemetrum-v1.2 telemetrum-v1.1 telemetrum-v1.0 \
	teledongle-v0.2 \
	telemini-v1.0 \
	telebt-v1.0 \
	telefire-v0.1 telefire-v0.2 \
	telerepeat-v1.0

ARMM3DIRS=\
	easymega-v1.0 easymega-v1.0/flash-loader \
	telemega-v0.1 telemega-v0.1/flash-loader \
	telemega-v1.0 telemega-v1.0/flash-loader \
	telemega-v2.0 telemega-v2.0/flash-loader \
	telemega-v3.0 telemega-v3.0/flash-loader \
	telemetrum-v2.0 telemetrum-v2.0/flash-loader \
	telemetrum-v3.0 telemetrum-v3.0/flash-loader \
	telegps-v0.3 telegps-v0.3/flash-loader \
	telegps-v1.0 telegps-v1.0/flash-loader \
	telegps-v2.0 telegps-v2.0/flash-loader \
	telelco-v0.2 telelco-v0.2/flash-loader \
	telelco-v0.3 telelco-v0.3/flash-loader \
	teledongle-v3.0 teledongle-v3.0/flash-loader \
	teleballoon-v2.0 \
	telebt-v3.0 telebt-v3.0/flash-loader \
	telebt-v4.0 telebt-v4.0/flash-loader \
	telelcotwo-v0.1 telelcotwo-v0.1/flash-loader \
	telefiretwo-v0.1 telefiretwo-v0.1/flash-loader \

ARMM0DIRS=\
	easymini-v1.0 easymini-v1.0/flash-loader \
	chaoskey-v1.0 chaoskey-v1.0/flash-loader \
	telemini-v3.0 telemini-v3.0/flash-loader \
	easymini-v2.0 easymini-v2.0/flash-loader \
	micropeak-v2.0 micropeak-v2.0/flash-loader

AVRDIRS=\
	micropeak microkite

SUBDIRS=

ifeq ($(strip $(HAVE_PDCLIB)),yes)
PDCLIB=pdclib
CLEAN_PDCLIB=clean-pdclib
endif

ifeq ($(strip $(HAVE_SDCC)),yes)
SUBDIRS+=$(SDCCDIRS)
endif

ifeq ($(strip $(HAVE_ARM_M3_CC)),yes)
SUBDIRS+=$(ARMM3DIRS)
foo=bar
endif

ifeq ($(strip $(HAVE_ARM_M0_CC)),yes)
SUBDIRS+=$(ARMM0DIRS)
baz=bletch
endif

ifeq ($(strip $(HAVE_AVR_CC)),yes)
SUBDIRS += $(AVRDIRS)
endif

ALLDIRS=$(SDCCDIRS) $(ARMM3DIRS) $(ARMM0DIRS) $(AVRDIRS)

all: all-local all-recursive

RECURSIVE_TARGETS = all-recursive install-recursive

$(RECURSIVE_TARGETS):
	@target=`echo $@ | sed 's/-recursive//'`; \
	for subdir in $(SUBDIRS); do \
		echo "Making $$target in $$subdir"; \
		(cd $$subdir && $(MAKE) $$target) || exit 1; \
	done

ALL_RECURSIVE_TARGETS = clean-recursive

$(ALL_RECURSIVE_TARGETS):
	@target=`echo $@ | sed 's/-recursive//'`; \
	for subdir in $(ALLDIRS); do \
		echo "Making $$target in $$subdir"; \
		(cd $$subdir && $(MAKE) $$target) || exit 1; \
	done

distclean:	clean

clean: clean-local clean-recursive

install: install-recursive

uninstall:

all-recursive: all-local

all-local: altitude.h altitude-pa.h altitude-pa-small.h ao_kalman.h ao_whiten.h $(PDCLIB)

altitude.h: make-altitude
	nickle $< > $@

altitude-pa.h: make-altitude-pa
	nickle $< > $@

altitude-pa-small.h: make-altitude-pa
	nickle $< --sample 3 > $@

ao_kalman.h: make-kalman kalman.5c kalman_micro.5c kalman_filter.5c load_csv.5c matrix.5c
	bash $< kalman > $@

ao_whiten.h: make-whiten
	nickle $< > $@

clean-local: $(CLEAN_PDCLIB)
	rm -f altitude.h ao_kalman.h

pdclib:
	mkdir -p $(PDCLIB_ROOT)/include $(PDCLIB_ROOT)/lib 
	cd ../pdclib && make && make prefix=`pwd`/../pdclib-root install

clean-pdclib:
	rm -rf $(PDCLIB_ROOT)
	cd ../pdclib && make clean

=== src/avr-demo/Makefile ===
#
# AltOS build
#
#
vpath % ..:../kernel:../product:../drivers:../avr
vpath make-altitude ..
vpath make-kalman ..
vpath kalman.5c ../kalman
vpath kalman_filter.5c ../kalman
vpath load_csv.5c ../kalman
vpath matrix.5c ../kalman
vpath ao-make-product.5c ../util

include ../avr/Makefile.defs

MCU=atmega32u4
DUDECPUTYPE=m32u4
#PROGRAMMER=stk500v2 -P usb
LOADARG=-p $(DUDECPUTYPE) -c $(PROGRAMMER) -e -U flash:w:

INC = \
	ao.h \
	ao_pins.h \
	altitude.h \
	ao_kalman.h

#
# Common AltOS sources
#
ALTOS_SRC = \
	ao_cmd.c \
	ao_mutex.c \
	ao_panic.c \
	ao_product.c \
	ao_romconfig.c \
	ao_serial_avr.c \
	ao_avr_stdio.c \
	ao_stdio.c \
	ao_task.c \
	ao_timer.c \
	ao_led.c \
	ao_usb_avr.c \
	ao_lcd.c

PRODUCT=AvrDemo-v0.0
MCU=atmega32u4
PRODUCT_DEF=-DAVR_DEMO
IDPRODUCT=0x000a
CFLAGS = $(PRODUCT_DEF) -I. -I../avr -I../kernel -I..
CFLAGS += -g -mmcu=$(MCU) -Wall -Wstrict-prototypes -Os -mcall-prologues

NICKLE=nickle

PROG=avr-demo

SRC=$(ALTOS_SRC) ao_demo.c ao_debug_avr.c
OBJ=$(SRC:.c=.o)

V=0
# The user has explicitly enabled quiet compilation.
ifeq ($(V),0)
quiet = @printf "  $1 $2 $@\n"; $($1)
endif
# Otherwise, print the full command line.
quiet ?= $($1)

all: $(PROG)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ)

$(PROG).hex: $(PROG)
	avr-size $(PROG)
	$(OBJCOPY) -R .eeprom -O ihex $(PROG) $@


load: $(PROG).hex
	$(LOADCMD) $(LOADARG)$(PROG).hex

../altitude.h: make-altitude
	nickle $< > $@

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

ao_product.rel: ao_product.c ao_product.h
	$(call quiet,CC) -c $(CFLAGS) -D PRODUCT_DEFS='\"ao_product.h\"' -o$@ $<

distclean:	clean

clean:
	rm -f $(OBJ)
	rm -f ao_product.h

install:

uninstall:

$(OBJ): ao.h ao_product.h

=== src/chaoskey-v0.1/Makefile ===
#
# AltOS build
#
#

include ../stmf0/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_pins.h \
	ao_product.h \
	ao_task.h \
	ao_adc_fast.h \
	ao_power.h \
	stm32f0.h

#
# Common AltOS sources
#
ALTOS_SRC = \
	ao_interrupt.c \
	ao_timer.c \
	ao_panic.c \
	ao_mutex.c \
	ao_dma_stm.c \
	ao_adc_fast.c \
	ao_crc_stm.c \
	ao_stdio.c \
	ao_led.c \
	ao_romconfig.c \
	ao_boot_chain.c \
	ao_usb_stm.c \
	ao_trng_send.c \
	ao_task.c \
	ao_power.c \
	ao_gpio.c \
	ao_product.c

PRODUCT=ChaosKey-hw-0.3-sw-$(VERSION)
PRODUCT_DEF=-DCHAOSKEY_V_0_1
IDVENDOR=0x1d50
IDPRODUCT=0x60c6

CFLAGS = $(PRODUCT_DEF) $(STMF0_CFLAGS) -g -Os

PROGNAME=chaoskey-v0.1
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_chaoskey.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ) $(LIBS)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -V $(IDVENDOR) -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) -o $@

$(OBJ): $(INC)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx
	rm -f ao_product.h

install:

uninstall:

=== src/chaoskey-v1.0/Makefile ===
#
# AltOS build
#
#

include ../stmf0/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_pins.h \
	ao_product.h \
	ao_task.h \
	ao_adc_fast.h \
	ao_power.h \
	ao_crc.h \
	stm32f0.h

#
# Common AltOS sources
#
ALTOS_SRC = \
	ao_interrupt.c \
	ao_timer.c \
	ao_panic.c \
	ao_mutex.c \
	ao_dma_stm.c \
	ao_adc_fast.c \
	ao_crc_stm.c \
	ao_stdio.c \
	ao_led.c \
	ao_romconfig.c \
	ao_boot_chain.c \
	ao_usb_stm.c \
	ao_trng_send.c \
	ao_task.c \
	ao_power.c \
	ao_gpio.c \
	ao_product.c

VENDOR=AltusMetrum
PROJECT_NAME=ChaosKey
PRODUCT=ChaosKey-hw-1.0-sw-$(VERSION)
PRODUCT_DEF=-DCHAOSKEY_V_1_0
IDVENDOR=0x1d50
IDPRODUCT=0x60c6

CFLAGS = $(PRODUCT_DEF) $(STMF0_CFLAGS) -g -Os

PROGNAME=chaoskey-v1.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx
METAINFO=org.altusmetrum.ChaosKey.metainfo.xml

SRC=$(ALTOS_SRC) ao_chaoskey.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ) $(LIBS)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -V $(IDVENDOR) -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) -o $@

$(OBJ): $(INC)

%.cab: $(PROG) $(HEX) $(METAINFO)
	gcab --create --nopath $@ $(PROG) $(HEX) $(METAINFO)

cab: $(VENDOR)-$(PROJECT_NAME)-$(VERSION).cab

check: $(METAINFO)
	appstream-util validate-relax $(METAINFO)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx
	rm -f ao_product.h
	rm -f *.cab

install:

uninstall:

=== src/cortexelf-v1/Makefile ===
#
# AltOS build
#
#

include ../stm/Makefile.defs
include ../scheme/Makefile-inc


INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_boot.h \
	ao_pins.h \
	ao_kalman.h \
	ao_product.h \
	ao_profile.h \
	ao_task.h \
	math.h \
	ao_mpu.h \
	stm32l.h \
	ao_vga.h \
	ao_draw.h \
	ao_draw_int.h \
	ao_font.h \
	ao_ps2.h \
	$(SCHEME_HDRS) \
	ao_flip_bits.h \
	Makefile

#PROFILE=ao_profile.c
#PROFILE_DEF=-DAO_PROFILE=1

#STACK_GUARD=ao_mpu_stm.c
#STACK_GUARD_DEF=-DHAS_STACK_GUARD=1


ALTOS_SRC = \
	ao_boot_chain.c \
	ao_interrupt.c \
	ao_product.c \
	ao_romconfig.c \
	ao_cmd.c \
	ao_config.c \
	ao_task.c \
	ao_errno.c \
	ao_stdio.c \
	ao_panic.c \
	ao_timer.c \
	ao_mutex.c \
	ao_serial_stm.c \
	ao_dma_stm.c \
	ao_spi_stm.c \
	ao_usb_stm.c \
	ao_exti_stm.c \
	ao_i2c_stm.c \
	ao_as1107.c \
	ao_matrix.c \
	ao_vga.c \
	ao_blt.c \
	ao_copy.c \
	ao_rect.c \
	ao_text.c \
	ao_line.c \
	ao_ps2.c \
	ao_console.c \
	ao_sdcard.c \
	ao_bufio.c \
	ao_fat.c \
	ao_flash_stm.c \
	ao_button.c \
	ao_event.c \
	ao_1802.c \
	ao_hex.c \
	$(SCHEME_SRCS) \
	ao_scheme_os_save.c \
	$(PROFILE) \
	$(SAMPLE_PROFILE) \
	$(STACK_GUARD)

PRODUCT=CortexELF-v1
PRODUCT_DEF=-DCORTEXELF
IDPRODUCT=0x000a

PROGNAME=cortexelf-v1
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

MAP=$(PROG).map

MAPFILE=-Wl,-M=$(MAP)

LDFLAGS=-L../stm -L/local/newlib-mini/arm-none-eabi/lib/thumb/v7-m/ -Wl,-Tcortexelf.ld $(MAPFILE) -nostartfiles
AO_CFLAGS=-I. -I../stm -I../kernel -I../drivers -I../draw -I../scheme -I.. -I/local/newlib-mini/arm-none-eabi/include
LIBS=-lc -lm -lgcc

CFLAGS = $(PRODUCT_DEF) $(STM_CFLAGS) $(PROFILE_DEF) $(SAMPLE_PROFILE_DEF) $(STACK_GUARD_DEF) -Os -g


SRC=$(ALTOS_SRC) ao_cortexelf.c
OBJ=$(SRC:.c=.o)

all:: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) cortexelf.ld
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ) $(LIBS)

../altitude-pa.h: make-altitude-pa
	nickle $< > $@

$(OBJ): $(INC)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

distclean:	clean

clean::
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx
	rm -f ao_product.h ao_flip_bits.h

ao_flip_bits.h: ao_flip_bits.5c
	nickle ao_flip_bits.5c > $@

include ../scheme/Makefile-scheme

install:

uninstall:

=== src/detherm/Makefile ===
#
# AltOS build
#
#

include ../stmf0/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_pins.h \
	ao_product.h \
	ao_task.h \
	stm32f0.h

#
# Common AltOS sources
#
ALTOS_SRC = \
	ao_interrupt.c \
	ao_timer.c \
	ao_panic.c \
	ao_mutex.c \
	ao_dma_stm.c \
	ao_usb_stm.c \
	ao_spi_stm.c \
	ao_exti_stm.c \
	ao_stdio.c \
	ao_led.c \
	ao_log.c \
	ao_log_mini.c \
	ao_sample.c \
	ao_data.c \
	ao_kalman.c \
	ao_flight.c \
	ao_report.c \
	ao_storage.c \
	ao_m25.c \
	ao_romconfig.c \
	ao_boot_chain.c \
	ao_ms5607.c \
	ao_convert_pa.c \
	ao_pwm.c \
	ao_servo.c \
	ao_task.c \
	ao_config.c \
	ao_cmd.c \
	ao_product.c

PRODUCT=Detherm-v1.0
PRODUCT_DEF=-DDETHERM_V_1_0
IDPRODUCT=0x0013

CFLAGS = $(PRODUCT_DEF) $(STMF0_CFLAGS) -g -Os

PROGNAME=detherm-v1.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_detherm.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) altos.ld
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ) $(LIBS)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) -o $@

$(OBJ): $(INC)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx
	rm -f ao_product.h

install:

uninstall:

=== src/draw/Makefile ===
BDF=5x7.bdf

ao_font.h: font-convert $(BDF)
	nickle font-convert $(BDF) > $@

=== src/easymini-v2.0/Makefile ===
#
# AltOS build
#
#

include ../stmf0/Makefile.defs

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_pins.h \
	ao_product.h \
	stm32f0.h

#
# Common AltOS sources
#

ALTOS_SRC = \
	ao_interrupt.c \
	ao_boot_chain.c \
	ao_romconfig.c \
	ao_product.c \
	ao_mutex.c \
	ao_panic.c \
	ao_stdio.c \
	ao_storage.c \
	ao_report.c \
	ao_ignite.c \
	ao_flight.c \
	ao_kalman.c \
	ao_sample.c \
	ao_data.c \
	ao_convert_pa.c \
	ao_convert_volt.c \
	ao_task.c \
	ao_log.c \
	ao_log_mini.c \
	ao_cmd.c \
	ao_config.c \
	ao_dma_stm.c \
	ao_timer.c \
	ao_exti_stm.c \
	ao_spi_stm.c \
	ao_adc_stm.c \
	ao_usb_stm.c \
	ao_m25.c \
	ao_ms5607.c \
	ao_beep_stm.c

PRODUCT=EasyMini-v2.0
PRODUCT_DEF=-DEASYMINI_V_2_0
IDPRODUCT=0x0026

CFLAGS = $(PRODUCT_DEF) $(STMF0_CFLAGS) -g -Os

PROGNAME=easymini-v2.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_easymini.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ) $(LIBS)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

$(OBJ): $(INC)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx
	rm -f ao_product.h

install:

uninstall:

=== src/lambdakey-v1.0/Makefile ===
#
# AltOS build
#
#

include ../stmf0/Makefile.defs

include ../scheme/Makefile-inc

NEWLIB_FULL=-lm -lc -lgcc

LIBS=$(NEWLIB_FULL)

INC = \
	ao.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_boot.h \
	ao_pins.h \
	ao_product.h \
	ao_task.h \
	$(SCHEME_HDRS) \
	ao_scheme_const.h \
	stm32f0.h \
	Makefile

ALTOS_SRC = \
	ao_boot_chain.c \
	ao_interrupt.c \
	ao_product.c \
	ao_cmd.c \
	ao_notask.c \
	ao_led.c \
	ao_stdio.c \
	ao_stdio_newlib.c \
	ao_panic.c \
	ao_timer.c \
	ao_usb_stm.c \
	ao_romconfig.c \
	$(SCHEME_SRCS)

PRODUCT=LambdaKey-v1.0
PRODUCT_DEF=-DLAMBDAKEY
IDPRODUCT=0x000a

CFLAGS = $(PRODUCT_DEF) -I. $(STMF0_CFLAGS) -Os -g

LDFLAGS=$(CFLAGS) -L$(TOPDIR)/stmf0 -Wl,-Tlambda.ld

MAP=$(PROG).map
NEWLIB=/local/newlib-mini
MAPFILE=-Wl,-M=$(MAP)
LDFLAGS=-L../stmf0 -L$(NEWLIB)/arm-none-eabi/lib/thumb/v6-m/ -Wl,-Tlambda.ld $(MAPFILE) -nostartfiles
AO_CFLAGS=-I. -I../stmf0 -I../kernel -I../drivers -I.. -I../scheme -isystem $(NEWLIB)/arm-none-eabi/include -DNEWLIB

PROGNAME=lambdakey-v1.0
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SRC=$(ALTOS_SRC) ao_lambdakey.c
OBJ=$(SRC:.c=.o)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ) lambda.ld
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ) $(LIBS)

$(OBJ): $(INC)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

ao_scheme_const.h: ../scheme/make-const/ao_scheme_make_const ao_lambdakey_const.scheme
	../scheme/make-const/ao_scheme_make_const -d FLOAT,VECTOR,QUASI,BIGINT -o $@ ao_lambdakey_const.scheme

load: $(PROG)
	stm-load $(PROG)

distclean:	clean

clean:
	rm -f *.o $(PROGNAME)-*.elf $(PROGNAME)-*.ihx ao_scheme_const.h
	rm -f ao_product.h

install:

uninstall:

=== src/microkite/Makefile ===
#
# Tiny AltOS build
#
#
vpath % ../attiny:../drivers:../kernel:../product:..
vpath ao-make-product.5c ../util
vpath make-altitude-pa ../util

include ../avr/Makefile.defs

PROGNAME=microkite-v0.1
PROG=$(PROGNAME)-$(VERSION).elf
HEX=$(PROGNAME)-$(VERSION).ihx

SCRIPT=microkite-load

PUBLISH_DIR=$(HOME)/altusmetrumllc/Binaries
PUBLISH_HEX=$(PUBLISH_DIR)/$(HEX)
PUBLISH_SCRIPT=$(PUBLISH_DIR)/$(SCRIPT)

MCU=attiny85
DUDECPUTYPE=t85
#PROGRAMMER=stk500v2 -P usb
LOADSLOW=-i 32 -B 32
LOADARG=-p $(DUDECPUTYPE) -c $(PROGRAMMER) -e -U flash:w:

#LDFLAGS=-L$(LDSCRIPTS) -Tavr25.x

ALTOS_SRC = \
	ao_micropeak.c \
	ao_spi_attiny.c \
	ao_led.c \
	ao_clock.c \
	ao_ms5607.c \
	ao_exti.c \
	ao_convert_pa.c \
	ao_report_micro.c \
	ao_notask.c \
	ao_eeprom_tiny.c \
	ao_panic.c \
	ao_log_micro.c \
	ao_async.c \
	ao_microflight.c \
	ao_microkalman.c

INC=\
	ao.h \
	ao_pins.h \
	ao_arch.h \
	ao_arch_funcs.h \
	ao_exti.h \
	ao_ms5607.h \
	ao_log_micro.h \
	ao_micropeak.h \
	altitude-pa.h

IDPRODUCT=0
PRODUCT=MicroKite-v0.1
PRODUCT_DEF=-DMICROPEAK
CFLAGS = $(PRODUCT_DEF) -I. -I../attiny -I../kernel -I.. -I../drivers -I../product
CFLAGS += -g -mmcu=$(MCU) -Wall -Wstrict-prototypes -O2 -mcall-prologues -DATTINY

NICKLE=nickle

SRC=$(ALTOS_SRC)
OBJ=$(SRC:.c=.o)

V=0
# The user has explicitly enabled quiet compilation.
ifeq ($(V),0)
quiet = @printf "  $1 $2 $@\n"; $($1)
endif
# Otherwise, print the full command line.
quiet ?= $($1)

all: $(PROG) $(HEX) microkite-load

CHECK=sh ../util/check-avr-mem

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) $(CFLAGS) -o $(PROG) $(OBJ)
	$(call quiet,CHECK) $(PROG) || ($(RM) -f $(PROG); exit 1)

$(HEX): $(PROG)
	avr-size $(PROG)
	$(OBJCOPY) -R .eeprom -O ihex $(PROG) $@


load: $(HEX)
	$(LOADCMD) $(LOADARG)$(HEX)

load-slow: $(HEX)
	$(LOADCMD) $(LOADSLOW) $(LOADARG)$(HEX)

ao_product.h: ao-make-product.5c ../Version
	$(call quiet,NICKLE,$<) $< -m altusmetrum.org -i $(IDPRODUCT) -p $(PRODUCT) -v $(VERSION) > $@

ao_product.o: ao_product.c ao_product.h

%.o : %.c $(INC)
	$(call quiet,CC) -c $(CFLAGS) $<

distclean:	clean

clean:
	rm -f *.o $(PROG) $(HEX) $(SCRIPT)
	rm -f ao_product.h

publish: $(PUBLISH_HEX) $(PUBLISH_SCRIPT)

$(PUBLISH_HEX): $(HEX)
	cp -a $(HEX) $@

$(PUBLISH_SCRIPT): $(SCRIPT)
	cp -a $(SCRIPT) $@

load-product:
	./$(SCRIPT) fast

load-product-slow:
	./$(SCRIPT) slow

../altitude-pa.h: make-altitude-pa
	nickle $< > $@

$(SCRIPT): $(SCRIPT).tmpl Makefile ../Version
	sed -e 's/%HEX%/$(HEX)/' -e 's/%LOADCMD%/$(LOADCMD)/' -e 's/%LOADARG%/$(LOADARG)/' -e 's/%LOADSLOW%/$(LOADSLOW)/' $(SCRIPT).tmpl > $@ || (rm $@ && exit 1)
	chmod +x $@

install:

uninstall:

$(OBJ): ao_product.h $(INC)

=== debian/changelog ===
altos (1.8.4-1) unstable; urgency=medium

  [ Bdale Garbee ]
  * update Releasing with changes discovered in 1.8.3 release process
  * releasing 1.8.4

  [ Keith Packard ]
  * doc: Don't 'publish' release notes, don't build pdf release notes
  * altos/scheme: Add ao_scheme_vector.c
  * altos/scheme: Support scheme subsetting via feature settings
  * altos/lambdakey-v1.0: Get this building again
  * altos/kernel: Allow ao_cmd to be built without tasking
  * altos/stm: Align 'data' to 8 bytes, just like textram
  * altos/scheme: apply const to places taking const strings.
  * altos/scheme: More compiler warning cleanups
  * altos/scheme: Use direct calls from frame to frame_vals mem functions
  * altos/scheme: inline some mem calls to reduce stack usage.
  * altos/lambdakey-v1.0: Make stack larger
  * altos/scheme: integer? is builtin on all versions
  * altos/scheme: swap BIGINT and STRING types
  * altos/lambdakey-v1.0: shrink scheme code to fit the ROM
  * ao-bringup/test-chaoskey: Make finding most recent device more reliable
  * altos/scheme: Use AO_SCHEME_IS_CONS in cons memory funcs
  * altos/scheme: Use memory manager mark code to note recursive print
  * altos/scheme: abort when we try to print an invalid value
  * altos/scheme: rearrange debugging defines
  * altos/scheme: Work around gcc 7.2.0 optimization bug in memory manager
  * altos/scheme: Compile scheme test with -O3
  * altos/scheme: Rework display/write code
  * altos/scheme: apply also needs to not free value list on lambdas
  * altos/scheme: (define (foo . bar)) has a pair, not list as card
  * altos/scheme: Clean up test CFLAGS
  * altos/scheme: Don't optimize ao_scheme_make_const
  * altos/scheme: ao_scheme__cons -> ao_scheme_cons
  * altos/scheme: AO_SCHEME_IS_CONS -> ao_scheme_is_cons
  * altos/scheme: Replace memory pool macros with inlines
  * altos/scheme: Replace per-type indexed stash with poly stash heap
  * altos/lambdakey-v1.0: Add back and/or macros
  * altos/easymini-v2.0: Adapt to final hardware pin assignment changes
  * ao-bringup: turnon_easymini was left with dfu_util disabled
  * altos/attiny: Add ADC implementation
  * altos/micropeak: Remove all compiler results
  * Doc updates for version 1.8.4
  * Bump for version 1.8.4

 -- Bdale Garbee <bdale@gag.com>  Thu, 21 Dec 2017 19:07:43 -0700

altos (1.8.3-1) unstable; urgency=medium

  [ Bdale Garbee ]
  * be more aggressive about removing and ignoring .mdwn files
  * tweak Releasing based on 1.8.2 release experience
  * don't exit on dfu-util errors, it's not reliable about reporting success
  * handle repeated invocations without failing as often
  * moving to TeleMega v3.0 by default
  * TeleMega v3.0 turnon scripts
  * take telescience out of the routine builds
  * TeleMega default is now v3.0
  * releasing 1.8.3

  [ Keith Packard ]
  * altoslib: Add tilt and pyro data to CSV export
  * altosuilib: Don't drain voice when terminating display
  * altoslib,altosuilib,altosui: log_format/device_type TeleGPS selects stateless
  * altos: Allow pyro config name to end with newline, not just space/tab
  * altoslib: Allow early bail-out on bad telemetry CRC
  * altosuilib: Show raw tick values in graph and info table
  * altoslib: Add user-selectable filter width for data smoothing
  * altoslib: Adapt KML output to make TRA record people happier
  * altosuilib: Add 'show marker' button to graphs
  * altoslib: Missing file for filter additions.
  * Set version to 1.8.2.1
  * altos: Stop storing pyro fired status in config block
  * altos: Add MPU9250 driver (accel/gyro only for now)
  * altoslib: Allow gps time later than requested if it's first
  * altoslib: Don't crash if there's no GPS coord to write KML
  * altoslib: Fix time series filter window computation
  * altos: Add MPU9250 support to self test and data
  * altoslib: Report un-adjusted ground accel in idle IMU monitor
  * altoslib: Save separate config for local and remote. Use in idle
  * altoslib: Move temp GPS API from cal_data to data_listener
  * altos: Remove cross-block storage I/O on cc1111
  * altos: Define AO_LOG_FORMAT in */ao_pins.h. Use in ao_cmd.c
  * altos: Share common logging code. Deal with corrupt initial flight records
  * altos: whitespace cleanup in ao_adc_stm.c
  * altos/stm: Add AO_EXTI_MODE_PULL_NONE
  * altosuilib: New line styles and colors for graphs. Selectable line width
  * altos/test: Adapt flight test to int16_t flight number type
  * altoslib: Don't write KML record when height data is missing
  * altoslib: Remove spurious semicolon in AltosReplayReader.java
  * altoslib: Improve EEprom download
  * altos: Fix inverted test for corrupt flight log
  * altos: Fix new GCC warnings
  * doc: Update for 1.8.3
  * altos/lisp: Add non-cons cdr support
  * altos/lisp: Add scheme-style bools (#t and #f)
  * altos/lisp: Add 'else' sematics to cond
  * altos/lisp: More schemisms
  * altos/test: Get lisp test building using Makefile-inc
  * altos/lisp: Lots more scheme bits
  * altos/test: More lisp test Makefile fixes
  * altos/lisp: Generate built-in lambda atoms for const creation
  * altos/lisp: Character consts. String and assoc builtins.
  * altos/lisp: Add apply
  * altos/lisp: Finish first pass through r7rs
  * altos/test: Add jiffy funcs to lisp test
  * altos/cortexelf-v1: Make lisp compile again
  * altos/lisp: Add 'big' ints -- 24 bits wide
  * altos/lisp: Fix some scheme compat issues
  * altos/lisp: Add floats
  * altos/test: Update to build altos lisp test app
  * altos/lisp: Rename progn to begin
  * altos/lisp: Add quasiquote
  * altos/lisp: Fix pairp builtin
  * altos/lisp: return from unmatched cond is #f, not nil
  * altos/lisp: Make let distinct from let*
  * altos/lisp: Split out frame vals from frame struct
  * altos/lisp: split set/def. Add def support to lambdas
  * altos/kernel: MPU9250 support
  * altos: Add TeleMega v3.0
  * altos: Build TeleMega v3.0 by default
  * altoslib: Add support for TeleMega v3.0 log files


=== debian/control ===
Source: altos
Section: electronics
Priority: optional
Maintainer: Bdale Garbee <bdale@gag.com>
Uploaders: Keith Packard <keithp@keithp.com>
Build-Depends: asciidoc,
               autoconf,
               automake,
               cc1111,
               debhelper (>= 10),
               default-jdk,
               docbook-xml,
               docbook-xsl,
               fop,
               freetts,
               gawk,
               gcc-arm-none-eabi,
               graphicsmagick | imagemagick,
               icnsutils,
               icoutils,
               libbluetooth-dev,
               libelf-dev,
               gtk-update-icon-cache,
               libjfreechart-java,
               libreadline-dev,
               librsvg2-bin,
               libtool,
               libusb-1.0-0-dev,
               netpbm,
               nickle,
               pkg-config,
               shared-mime-info,
               swig,
               xmlto,
               xsltproc
Standards-Version: 4.0.0
Homepage: http://altusmetrum.org/AltOS
Vcs-Git: git://git.gag.com/fw/altos -b debian
Vcs-Browser: http://git.gag.com/?p=fw/altos

Package: altos
Architecture: any
Depends: default-jre | java2-runtime,
         freetts,
         libjfreechart-java,
         nickle,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: slim | gdm
Replaces: altusmetrum-themes, slim-altusmetrum
Conflicts: altusmetrum-themes, slim-altusmetrum
Description: Altus Metrum firmware and utilities
 Firmware and utilities needed to support high power model rocketry products
 from Altus Metrum, including TeleMetrum, TeleMini, and TeleDongle.
 .
 See http://altusmetrum.org/ for more information.
